commit 541f3a1dad4a1829409dd288991525fecd410f02
Author:     Thomas Holder <thomas@thomas-holder.de>
AuthorDate: Sun Feb 20 21:31:07 2022 +0100
Commit:     Thomas Holder <thomas@thomas-holder.de>
CommitDate: Sun Feb 20 21:31:07 2022 +0100

    Fix "unrotated ellipse scaling" special-case
    
    For scalings which invert x and/or y.
    
    Fixes https://gitlab.com/inkscape/inkscape/-/issues/2442
    Fixes https://gitlab.com/inkscape/inkscape/-/issues/1607

diff --git a/src/2geom/ellipse.cpp b/src/2geom/ellipse.cpp
index 61769369..f076cfab 100644
--- a/src/2geom/ellipse.cpp
+++ b/src/2geom/ellipse.cpp
@@ -305,8 +305,8 @@ Ellipse &Ellipse::operator*=(Affine const& m)
         _angle = atan2(v);
         return *this;
     } else if (mwot.isScale(0) && _angle.radians() == 0) {
-        _rays[X] = _rays[X] * mwot[0];
-        _rays[Y] = _rays[Y] * mwot[3];
+        _rays[X] *= std::abs(mwot[0]);
+        _rays[Y] *= std::abs(mwot[3]);
         _center = new_center;
         return *this;
     }
